// CfgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Fencryptor.h"
#include "CfgDlg.h"

#include <Winreg.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCfgDlg dialog


CCfgDlg::CCfgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCfgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCfgDlg)
	//}}AFX_DATA_INIT
}


void CCfgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCfgDlg)
	DDX_Control(pDX, IDC_MODE_COMBO, m_mode);
	DDX_Control(pDX, IDC_KEYTYPE_COMBO, m_keytype);
	DDX_Control(pDX, IDC_ALGO_COMBO, m_algo);
	DDX_Control(pDX, IDC_KEYSETTYPE_COMBO, m_keyset_type);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCfgDlg, CDialog)
	//{{AFX_MSG_MAP(CCfgDlg)
	ON_BN_CLICKED(ID_CONFIG_SAVE, OnConfigSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCfgDlg message handlers

void CCfgDlg::OnConfigSave() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
    char buf[100];
	sprintf( buf, "%d,%d,%d,%d,",
		m_keytype.GetCurSel(), 
		m_keyset_type.GetCurSel(),
	    m_algo.GetCurSel(),
		m_mode.GetCurSel() );

	HKEY hKey, hSubKey, hkResult;
	LPDWORD  lpdwDisposition = NULL;
	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software", 0, KEY_READ|KEY_CREATE_SUB_KEY, &hKey) != ERROR_SUCCESS) {
		AfxMessageBox("Error Opening Registry1", MB_OK);
	    return;
    }

    if( RegCreateKeyEx( hKey, "Fencryptor", 0, NULL,      
        REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hSubKey,
		lpdwDisposition ) != ERROR_SUCCESS ) {
		     AfxMessageBox( "Error Creating Registry1", MB_OK);
	         return;
    }
    RegCloseKey(hKey);

	if( RegCreateKeyEx( hSubKey, "Fencryptor", 0, NULL,      
        REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hkResult,
		lpdwDisposition ) != ERROR_SUCCESS ) {
		     AfxMessageBox( "Error Creating Registry2", MB_OK);
	         return;
    }
	RegCloseKey(hSubKey);

	if( RegSetValueEx( hkResult, "Config", NULL, REG_SZ, (const unsigned char*)buf, strlen(buf) ) != ERROR_SUCCESS ) {
		AfxMessageBox( "Error Saving Registry", MB_OK);
		return;
	}
	RegCloseKey(hkResult);

    AfxMessageBox( "Configuration is saved in registry !!!", MB_OK);

}

BOOL CCfgDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	HKEY hKey, hSubKey, hkResult;

	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software", 0, KEY_READ|KEY_CREATE_SUB_KEY, &hKey) != ERROR_SUCCESS) {
		SetDefault();
		return TRUE;
    }
	
    if( RegOpenKeyEx( hKey, "Fencryptor", 0,
		KEY_READ, &hSubKey ) != ERROR_SUCCESS ) {
	    SetDefault();
	    return TRUE;
    }
    RegCloseKey(hKey);

	if( RegOpenKeyEx( hSubKey, "Fencryptor", 0,    
		KEY_READ, &hkResult ) != ERROR_SUCCESS ) {
		SetDefault();
	    return TRUE;
    }
	RegCloseKey(hSubKey);

	char buf[100];
	DWORD dwSize;
	DWORD dwType;

	if( RegQueryValueEx( hkResult, "Config", NULL, &dwType, NULL, &dwSize ) != ERROR_SUCCESS ) {
		SetDefault();
		return TRUE;
	}

	if( RegQueryValueEx( hkResult, "Config", NULL, &dwType, (unsigned char*)buf, &dwSize ) != ERROR_SUCCESS ) {
		SetDefault();
		return TRUE;
	}
	RegCloseKey(hkResult);
    
    buf[1] = buf[3] = buf[5] = buf[7] = '\0';

	m_keytype.SetCurSel( atoi(buf) );
    m_keyset_type.SetCurSel( atoi(buf+2) );
	m_algo.SetCurSel( atoi(buf+4) );
	m_mode.SetCurSel( atoi(buf+6) );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCfgDlg::SetDefault()
{	
	// secret key
	m_keytype.SetCurSel(0);
    // PGP
	m_keyset_type.SetCurSel(0);
	// Algo 3DES
	m_algo.SetCurSel(1);
	// Mode CFB
	m_mode.SetCurSel(2);

}
