// PublicDlg.cpp : implementation file
//

#include "stdafx.h"

extern "C" {
#include "Capi.h"
}

#include "Fencryptor.h"
#include "PublicDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPublicDlg dialog


CPublicDlg::CPublicDlg(int KeyType, CWnd* pParent /*=NULL*/)
	: CDialog(CPublicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPublicDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    internalKeyType = KeyType;

}


void CPublicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPublicDlg)
	DDX_Control(pDX, IDC_SIGNER_VERIFY_BUTTON, m_signer_button);
	DDX_Control(pDX, IDC_SIGNER_EDIT, m_signer);
	DDX_Control(pDX, IDC_SECRET_PASS_EDIT, m_secret_passphrase);
	DDX_Control(pDX, IDC_RCPT_VERIFY_BUTTON, m_rcpt_button);
	DDX_Control(pDX, IDC_RCPT_EDIT, m_recipient);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPublicDlg, CDialog)
	//{{AFX_MSG_MAP(CPublicDlg)
	ON_BN_CLICKED(IDC_RCPT_VERIFY_BUTTON, OnRcptVerifyButton)
	ON_BN_CLICKED(IDC_SIGNER_VERIFY_BUTTON, OnSignerVerifyButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPublicDlg message handlers

BOOL CPublicDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if( internalKeyType == 1 ) {
		m_recipient.EnableWindow();
		m_rcpt_button.EnableWindow();
	}
	else if( internalKeyType == 2 ) {
		m_signer.EnableWindow();
		m_signer_button.EnableWindow();
		m_secret_passphrase.EnableWindow();
	}
	else { // internalKeyType == 3
		m_recipient.EnableWindow();
		m_rcpt_button.EnableWindow();
		m_signer.EnableWindow();
		m_signer_button.EnableWindow();
		m_secret_passphrase.EnableWindow();
	}

	char pgppath[100];
	if( ::GetEnvironmentVariable( "PGPPATH", pgppath, 100) == 0 ) {
		AfxMessageBox( "Won't work if PGP has not been set up !!!", MB_OK);
		EndDialog(IDCANCEL);
		return FALSE;
	}
	sprintf( pubring, "%s\\pubring.pgp", pgppath);
	sprintf( secring, "%s\\secring.pgp", pgppath);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPublicDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	m_recipient.GetWindowText(recipient);
    m_signer.GetWindowText(signer);
	m_secret_passphrase.GetWindowText(passphrase);

	if( ( internalKeyType == 1 || internalKeyType == 3 ) 
		  && recipient == "" ) {
		AfxMessageBox( "Recipient cannot be null !!!", MB_OK);
	    return;
    }
	if( ( internalKeyType == 2 || internalKeyType == 3 ) ) {
		if ( signer == "" ) {
			AfxMessageBox( "Signer cannot be null !!!", MB_OK);
		    return;
		}
		if( passphrase == "" ) {
			AfxMessageBox( "Passphrase cannot be null !!!", MB_OK);
			return;
		}
	}
	CDialog::OnOK();
}

void CPublicDlg::OnRcptVerifyButton() 
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE);
	m_recipient.GetWindowText(recipient);
    m_signer.GetWindowText(signer);
	m_secret_passphrase.GetWindowText(passphrase);

	int status;
	CRYPT_KEYSET cryptKeyset;
	CRYPT_CONTEXT cryptContext;
    char buf[100];
	status = cryptExtKeysetOpen( &cryptKeyset, pubring,
					CRYPT_KEYSET_PGP );
    if( cryptStatusError( status ) ) {
		sprintf( buf, "Couldn't open public key ring %s,\r\nError code %d.\r\n",
				  pubring, status );
		AfxMessageBox( buf, MB_OK);
		return;
	};
    status = cryptGetKey( cryptKeyset, &cryptContext, recipient );
    if( cryptStatusError( status ) ) {
	    sprintf( buf, "Couldn't get public key for %s,\r\nError code %d.\r\n",
				recipient, status );
		AfxMessageBox(buf, MB_OK);
		return;
    }
    cryptKeysetClose( cryptKeyset );
    AfxMessageBox( "Recipient is found.", MB_OK);
}

void CPublicDlg::OnSignerVerifyButton() 
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE);
	m_recipient.GetWindowText(recipient);
    m_signer.GetWindowText(signer);
	m_secret_passphrase.GetWindowText(passphrase);

	int status;
	CRYPT_KEYSET cryptKeyset;
	CRYPT_CONTEXT signContext;
    char buf[100];

	status = cryptExtKeysetOpen( &cryptKeyset, secring,
						CRYPT_KEYSET_PGP );
	if( cryptStatusError( status ) ) {
		 sprintf( buf, "Couldn't open private key file %s,\r\nError code %d.\r\n",
		      secring, status );
		 AfxMessageBox( buf, MB_OK);
		 return;
	}
	status = cryptGetKeyEx( cryptKeyset, &signContext, signer, passphrase );
	passphrase == "";
	passphrase.FreeExtra();

	if( cryptStatusError( status ) ) {
		sprintf( buf, "Couldn't get private key for %s,\r\nError code %d\r\n",
							signer, status );
		AfxMessageBox( buf, MB_OK);
		return;
	}
	cryptKeysetClose( cryptKeyset );
	AfxMessageBox( "Signer verification is OK.", MB_OK);
}
